package com.menagerie.ophelia

import android.os.Bundle
import android.view.Window
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.compose.material3.Surface
import com.menagerie.ophelia.database.polycule.PolyculeApplication
import com.menagerie.ophelia.database.polycule.PolyculeDatabaseManager
import com.menagerie.ophelia.ui.theme.OpheliaTheme
import com.menagerie.ophelia.view.PolyculeApp

class MainActivity : ComponentActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContent {
            OpheliaTheme {
                val repository = (application as PolyculeApplication).repository
                PolyculeDatabaseManager.polyculeRepository = repository
                Surface {
                    PolyculeApp()
                }
            }
        }
    }
}
