package com.menagerie.ophelia.database.polycule

import android.util.Log
import androidx.lifecycle.LiveData
import androidx.lifecycle.asLiveData
import com.menagerie.ophelia.database.polycule.entity.Bio
import com.menagerie.ophelia.database.polycule.entity.BioDao
import kotlinx.coroutines.flow.Flow

class PolyculeRepository(
    private val bioDao: BioDao
) {
    suspend fun upsertBio(bio: Bio) {
        bioDao.upsert(bio)
    }

    fun getAlphabetisedBios(): Flow<List<Bio>> {
        return bioDao.getAllAlphabetisedBios()
    }

    fun getBio(bioId: Long): Flow<Bio> {
        return bioDao.getBio(bioId)
    }

    fun getAllBios(): Flow<List<Bio>> {
        return bioDao.getAllBios()
    }

    suspend fun insert(bio: Bio) {
        bioDao.insert(bio)
    }

    suspend fun delete(bio: Bio) {
        bioDao.delete(bio)
    }

    fun hasPolycule() = false
}