package com.menagerie.ophelia.view.newUser

import android.annotation.SuppressLint
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.material3.Button
import androidx.compose.material3.LinearProgressIndicator
import androidx.compose.material3.Scaffold
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.getValue
import androidx.compose.runtime.livedata.observeAsState
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.setValue
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import androidx.lifecycle.viewmodel.compose.viewModel
import com.menagerie.ophelia.database.polycule.entity.Bio
import com.menagerie.ophelia.database.polycule.entity.viewmodel.BioListViewModel
import com.menagerie.ophelia.view.OpheliaFace
import com.menagerie.ophelia.view.OpheliaWhatsYourName
import com.menagerie.ophelia.view.biographies.insertBioInDB
import com.menagerie.ophelia.view.components.InputFieldState

@SuppressLint("UnusedMaterial3ScaffoldPaddingParameter")
@Composable
fun AddNameScreen(
    onGo: () -> Unit,
) {
    val inputViewModel = BioListViewModel.InputBioViewModel()
    val mBioListViewModel: BioListViewModel = viewModel(
        factory = BioListViewModel.BioListViewModelFactory()
    )
    Scaffold {
        Column(
            modifier = Modifier.fillMaxSize()
        ) {
            val bio: Bio by inputViewModel.bio.observeAsState(Bio())

            OpheliaFace(
                modifier = Modifier
                    .align(Alignment.CenterHorizontally)
                    .padding(top = 12.dp)
            )
            LinearProgressIndicator(
                progress = 0f,
                modifier = Modifier.fillMaxWidth()
            )
            OpheliaWhatsYourName(modifier = Modifier)
            InputFieldState(
                value = bio.name,
                label = "name",
                modifier = Modifier
                    .width(120.dp)
            ) { inputViewModel.onNameChange(it) }
            Spacer(
                modifier = Modifier
                    .fillMaxSize()
                    .weight(1f)

            )
            Button(
                modifier = Modifier
                    .align(Alignment.End),
                onClick = {
                    insertBioInDB(inputViewModel.bio.value, mBioListViewModel)
                    onGo()
                }
            ) {
                Text(text = "Continue")
            }
        }
    }
}

